import 'package:flutter/material.dart';

class CommonWidgets {
  static Color primaryColor = const Color(0xFFA02058);
  static Widget commonUnderLineTextField(
      {required String labelText, bool? isObscure, Widget? prefix, Widget? suffixIcon, Color? themeColor}) {
    return TextFormField(
        obscureText: isObscure ?? false,
        cursorColor: themeColor ?? primaryColor,
        style: const TextStyle(color: Colors.black, fontSize: 15, fontWeight: FontWeight.w400),
        onChanged: (str) {
          if (str.length >= 15) {
            print("object greated than 15");
            //var cardType = getCardType(str);
            if (str.contains(RegExp(r'^(5[1-5][0-9]{4}|677189)[0-9]{5,}$'))) {
              //return "Master card";
              print("Master card");
            } else if(str.contains(RegExp(r'^4[0-9]{6,}([0-9]{3})?$'))) {
              //return "visa";
              print("visa");
            } else if(str.contains(RegExp(r'^3[47][0-9]{5,}$'))) {
              //return "American Express";
              print("American express");
            } else if(str.contains(RegExp(r'^(36|38|30[0-5])'))) {
              //return "Diners Club";
              print("Diners club");
            } else if(str.contains(RegExp(r'^(5018|5020|5038|5[6-9]|6020|6304|6703|6759|676[1-3])'))) {
              //return "Mestro";
              print("Mestro");
            }
          }
        },
        decoration: InputDecoration(
            helperText: "",
            contentPadding: const EdgeInsets.only(bottom: 3),
            prefix: prefix,
            suffixIcon: suffixIcon ?? SizedBox(),
            suffixIconConstraints: BoxConstraints.tightFor(),
            alignLabelWithHint: true,
            labelStyle: TextStyle(
              color: const Color(0xFF000000).withOpacity(0.5),
            ),
            labelText: labelText,
            border: UnderlineInputBorder(
                borderSide: BorderSide(color: const Color(0xFF000000).withOpacity(0.3), width: 1.5)),
            errorBorder: UnderlineInputBorder(
                borderSide: BorderSide(color: const Color(0xFF000000).withOpacity(0.3), width: 1.5)),
            enabledBorder: UnderlineInputBorder(
                borderSide: BorderSide(color: const Color(0xFF000000).withOpacity(0.3), width: 1.5)),
            focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: themeColor ?? primaryColor, width: 1.5)),
            disabledBorder:
            UnderlineInputBorder(borderSide: BorderSide(color: const Color(0xFF000000).withOpacity(0.3)))));
  }

  static Widget commonTextField({required String labelText, Widget? prefix, Widget? suffixIcon, Color? themeColor,bool? obscure}) {
    return TextFormField(obscureText: obscure??false,
        cursorColor: themeColor ?? primaryColor,
        style: const TextStyle(color: Colors.black, fontSize: 15, fontWeight: FontWeight.w400),
        decoration: InputDecoration(
            helperText: "",
            contentPadding: const EdgeInsets.only(left: 12),
            alignLabelWithHint: true,
            labelStyle: TextStyle(
              color: const Color(0xFF000000).withOpacity(0.5),
            ),
            suffixIcon: suffixIcon ?? SizedBox(),
            suffixIconConstraints: BoxConstraints.tightFor(),
            labelText: labelText,
            border: OutlineInputBorder(
                borderSide: BorderSide(color: const Color(0xFFDDDDDD).withOpacity(0.3), width: 1.5),
                borderRadius: BorderRadius.circular(10)),
            errorBorder: OutlineInputBorder(
                borderSide: BorderSide(color: const Color(0xFFDDDDDD).withOpacity(0.3), width: 1.5),
                borderRadius: BorderRadius.circular(10)),
            enabledBorder: OutlineInputBorder(
                borderSide: BorderSide(color: const Color(0xFFDDDDDD).withOpacity(0.3), width: 1.5),
                borderRadius: BorderRadius.circular(10)),
            focusedBorder: OutlineInputBorder(
                borderSide: BorderSide(color: themeColor ?? primaryColor, width: 1.5),
                borderRadius: BorderRadius.circular(10)),
            disabledBorder: OutlineInputBorder(
                borderSide: BorderSide(color: const Color(0xFFDDDDDD).withOpacity(0.3)),
                borderRadius: BorderRadius.circular(10))));
  }

  String getCardType(String cardNumber){
    if (cardNumber.contains(RegExp(r'^(5[1-5][0-9]{4}|677189)[0-9]{5,}$'))) {
      return "Master card";
    } else if(cardNumber.contains(RegExp(r'^4[0-9]{6,}([0-9]{3})?$'))) {
      return "visa";
    } else if(cardNumber.contains(RegExp(r'^3[47][0-9]{5,}$'))) {
      return "American Express";
    } else if(cardNumber.contains(RegExp(r'^(36|38|30[0-5])'))) {
      return "Diners Club";
    } else if(cardNumber.contains(RegExp(r'^(5018|5020|5038|5[6-9]|6020|6304|6703|6759|676[1-3])'))) {
      return "Mestro";
    }
    return "";
  }
}
